﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Data;
using System.IO;
using Library.Services;
using Library.DataModel;
using System.Windows.Ria.Data;

namespace Library.Pages {
    public partial class HomePage : Page {

        private LibraryManagementContext _context;

        public HomePage() {
            InitializeComponent();
            _context = new LibraryManagementContext();
            booksDataGrid.ItemsSource = _context.Books;
        }

        // Executes when the user navigates to this page.
        protected override void OnNavigatedTo(NavigationEventArgs e) {
            EntityQuery<Book> bookQuery =
                from b in _context.GetBooksQuery()
                where b.Author.StartsWith("A")
                select b;

            _context.Load(bookQuery);
        }

        private void searchButton_Click(object sender, RoutedEventArgs e) {
            _context.Books.Clear();

            EntityQuery<Book> bookQuery = _context.SearchBooksQuery(searchTextBox.Text);
            _context.Load(bookQuery);
        }
    }
}