﻿
namespace Library.Services {
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Linq;
    using System.Web.Ria;
    using System.Web.Ria.Data;
    using System.Web.DomainServices;
    using System.Data.Linq;
    using System.Web.DomainServices.LinqToSql;
    using Library.Models;

    public class LibraryService : LinqToSqlDomainService<LibraryDBDataContext> {

        protected override LibraryDBDataContext CreateContext() {
            LibraryDBDataContext context = base.CreateContext();

            DataLoadOptions options = new DataLoadOptions();
            options.LoadWith<Book>(b => b.Category);

            context.LoadOptions = options;
            return context;
        }

        public virtual IQueryable<Book> GetBooks() {
            return from b in Context.Books
                   where b.Missing == false
                   orderby b.PublishDate descending
                   select b;
        }

        public virtual void AddBook(Book book) {
            Context.Books.InsertOnSubmit(book);
        }

        public virtual void UpdateBook(Book book) {
            Context.Books.Attach(book, ChangeSet.GetOriginal(book));
        }
    }
}

