﻿// SyncingApplication.cs
//

using System;

namespace System.Windows.Ria.Sync {

    public static class SyncingApplication {

        private static int _syncCount;

        public static event EventHandler Syncing;

        public static bool IsSyncing {
            get {
                return _syncCount != 0;
            }
        }

        public static void EnterSync() {
            _syncCount++;
            if (_syncCount == 1) {
                if (Syncing != null) {
                    Syncing(null, EventArgs.Empty);
                }
            }
        }

        public static void ExitSync() {
            if (_syncCount > 0) {
                _syncCount--;
                if (Syncing != null) {
                    Syncing(null, EventArgs.Empty);
                }
            }
        }
    }
}
